<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblPreguntasXUsuarioRepository;

final class TblPreguntasXUsuarioService
{
    private TblPreguntasXUsuarioRepository $TblPreguntasXUsuarioRepository;

    public function __construct(TblPreguntasXUsuarioRepository $TblPreguntasXUsuarioRepository)
    {
        $this->TblPreguntasXUsuarioRepository = $TblPreguntasXUsuarioRepository;
    }

    public function checkAndGet(int $TblPreguntasXUsuarioId): object
    {
        return $this->TblPreguntasXUsuarioRepository->checkAndGet($TblPreguntasXUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblPreguntasXUsuarioRepository->getAll();
    }

    public function getOne(int $TblPreguntasXUsuarioId): object
    {
        return $this->checkAndGet($TblPreguntasXUsuarioId);
    }

    public function create(array $input): object
    {
        $TblPreguntasXUsuario = json_decode((string) json_encode($input), false);

        return $this->TblPreguntasXUsuarioRepository->create($TblPreguntasXUsuario);
    }

    public function update(array $input, int $TblPreguntasXUsuarioId): object
    {
        $TblPreguntasXUsuario = $this->checkAndGet($TblPreguntasXUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblPreguntasXUsuarioRepository->update($TblPreguntasXUsuario, $data);
    }

    public function delete(int $TblPreguntasXUsuarioId): void
    {
        $this->checkAndGet($TblPreguntasXUsuarioId);
        $this->TblPreguntasXUsuarioRepository->delete($TblPreguntasXUsuarioId);
    }
}
